﻿<AML>
 <Item type="Method" id="0E06AD35F02943468CC95F17FBE6E961" action="add">
  <execution_allowed_to keyed_name="World" type="Identity">A73B655731924CD0B027E4F4D5FCC0A9</execution_allowed_to>
  <method_code><![CDATA[            /* *****************************************************************************
            Method Name:			acc_sr_zr_oss_exempt_rpt
            Created By/Company:		SolidCAD 
            Creation Date:			2018-081-23
            Description:
                -Getting Required Information for Report.

            Hooks:
                Called by:	acc_sr_zr_oss_exempt_rpt_cal

            Inputs:
                acc_tax_type,
                acc_from_date,
                acc_to_date

            Revisions:
                Rev Date		Modified By			Description
                2018-07-20		Chan				Add property(acc_currecny_code),Update property(erp_company as string) And Update query
            ***************************************************************************** */

            //WARNING: DO NOT FORGET TO DISABLE THIS IN A PRODUCTION ENVIRONMENT!!!
            //if(System.Diagnostics.Debugger.Launch()) System.Diagnostics.Debugger.Break();

            string MethodName = "acc_sr_zr_oss_exempt_rpt";

            //***** GRANT IDENTITY PRIVILEGES
            // grantIdentityPrivileges("Super User"); // If this is enabled always revoke the privileges in the Finally below.
            //*******************************
            Innovator myInnovator = this.getInnovator();
            Item result = this; // default return value.

            try
            {
                var acc_from_date = this.getProperty("acc_from_date", "");
                var acc_to_date = this.getProperty("acc_to_date", "");
                var acc_tax_type = this.getProperty("acc_tax_type", "");

                /* To Get Company Info */
                var company = myInnovator.applyMethod("acc_getCompanyInfo", "");
                var erp_com_name = company.getProperty("erp_com_name");
                /* End */

                string s_acc_date = "";
                string f_acc_date = "";
                string t_acc_date = "";
                var pop_sg_sub_amount = "";
                var clear_report_data = myInnovator.applySQL("DELETE FROM innovator.acc_sr_zr_oss_exempt_report");

                string date_condition1 = "   AND (Convert(Date,innovator.ConvertToLocal(SOP_SALE_INVOICE.sop_invoice_date,DEFAULT),111) Between Convert(Date,'" + acc_from_date + "',111) "
                + " and  Convert(Date,'" + acc_to_date + "',111))";
                string date_condition2 = "   AND (Convert(Date,innovator.ConvertToLocal(pop_purchase_invoice.pop_invoice_date,DEFAULT),111) Between Convert(Date,'" + acc_from_date + "',111) "
                + " and  Convert(Date,'" + acc_to_date + "',111))";

                var query = "select pop_currency,innovator.ConvertToLocal(acc_date,DEFAULT) as acc_date,acc_invoice_no,invoice_desc,pop_sg_total_amount,pop_sg_sub_amount,erp_company,tax_sub_title,tax_title,acc_total_label,pop_sg_gst_amount,pop_sub_amount from ( select pop_currency,SOP_SALE_INVOICE.sop_invoice_date as acc_date,SOP_SALE_INVOICE.sop_invoice_no as acc_invoice_no,sop_invoice_desc as invoice_desc,sum(pop_sg_total_amount) as pop_sg_total_amount,sum(pop_sg_gst_amount) as pop_sg_gst_amount,sum(pop_sg_sub_amount) as pop_sg_sub_amount,sum(pop_sub_amount) as pop_sub_amount,SOP_SALE_INVOICE.erp_company," +
                " CASE WHEN ACC_TAX_TYPE = 'Standard Rate'   THEN '1.Total value of standard-rated supplies' " +
                " WHEN ACC_TAX_TYPE = 'Zero Rate'   THEN '2.Total value of zero-rated supplies' " +
                "  WHEN ACC_TAX_TYPE = 'Out Of Scope'   THEN '3.Total value of exempt supplies'  ELSE ''  END AS tax_sub_title,'Supplies' as tax_title,'Total value of (1)+(2)+(3)' as acc_total_label " +
                " from innovator.SOP_SALE_INVOICE inner join innovator.acc_journal_header on acc_journal_header.acc_sop_voucher_reference=SOP_SALE_INVOICE.id  where 1=1 AND  acc_journal_header.acc_transactiontype='Sale' " + date_condition1 + " group by acc_tax_type,SOP_SALE_INVOICE.erp_company,SOP_SALE_INVOICE.sop_invoice_no,sop_invoice_desc,SOP_SALE_INVOICE.sop_invoice_date,pop_currency "
                + " union "
                + " select pop_currency,POP_PURCHASE_INVOICE.pop_invoice_date as acc_date,POP_PURCHASE_INVOICE.pop_invoice_no as acc_invoice_no,pop_invoice_desc as invoice_desc,sum(pop_sg_total_amount) as pop_sg_total_amount,sum(pop_sg_gst_amount) as pop_sg_gst_amount, " +
                " sum(pop_sg_sub_amount) as pop_sg_sub_amount,sum(pop_sub_amount) as pop_sub_amount,erp_company, " +
                " '4.Total value of taxable purchase' as tax_sub_title,'Purchases' as tax_title,'' as acc_total_label " +
                " from innovator.POP_PURCHASE_INVOICE  inner join innovator.acc_journal_header on acc_journal_header.acc_pop_voucher_reference=POP_PURCHASE_INVOICE.id where 1=1 AND  acc_journal_header.acc_transactiontype='Purchase' " + date_condition2 + " group by erp_company,POP_PURCHASE_INVOICE.pop_invoice_no,pop_invoice_desc,POP_PURCHASE_INVOICE.pop_invoice_date,pop_currency ) results order by tax_sub_title,Convert(Date,acc_date,111),acc_invoice_no ";

                Item _get_data = myInnovator.applySQL(query);

                var _get_data_count = _get_data.getItemCount();
                if (_get_data_count > 0)
                {
                    for (int i = 0; i < _get_data_count; i++)
                    {
                        var j = i + 1;
                        var _get_data_result = _get_data.getItemByIndex(i);
                        var sop_invoice_date = _get_data_result.getProperty("acc_date");
                        DateTime dt_acc_date = DateTime.Parse(sop_invoice_date);
                        dt_acc_date = new DateTimeOffset(dt_acc_date, TimeSpan.FromHours(0)).ToLocalTime().DateTime;
                        s_acc_date = dt_acc_date.ToString("yyyy-MM-dd");

                        DateTime from_acc_date = DateTime.Parse(acc_from_date);
                        f_acc_date = from_acc_date.ToString("yyyy-MM-dd");

                        DateTime to_acc_date = DateTime.Parse(acc_to_date);
                        t_acc_date = to_acc_date.ToString("yyyy-MM-dd");

                        var acc_month = _get_data_result.getProperty("acc_month");

                        var pop_sub_amount = _get_data_result.getProperty("pop_sub_amount");
                        pop_sg_sub_amount = _get_data_result.getProperty("pop_sg_sub_amount");
                        var pop_sg_gst_amount = _get_data_result.getProperty("pop_sg_gst_amount");
                        var erp_company = _get_data_result.getProperty("erp_company");
                        var tax_sub_title = _get_data_result.getProperty("tax_sub_title");
                        var tax_title = _get_data_result.getProperty("tax_title");
                        var acc_total_label = _get_data_result.getProperty("acc_total_label");
                        var sop_invoice_no = _get_data_result.getProperty("acc_invoice_no");
                        var pop_currency = _get_data_result.getProperty("pop_currency");
                        var acc_invoice_description = _get_data_result.getProperty("invoice_desc");
                        
                        Item acc_sr_zr_oss_exempt_report = myInnovator.newItem("acc_sr_zr_oss_exempt_report", "add");
                        acc_sr_zr_oss_exempt_report.setProperty("acc_invoice_date", s_acc_date);
                        acc_sr_zr_oss_exempt_report.setProperty("erp_company", erp_com_name);
                        acc_sr_zr_oss_exempt_report.setProperty("acc_tax_title", tax_title);
                        acc_sr_zr_oss_exempt_report.setProperty("acc_tax_sub_title", tax_sub_title);
                        acc_sr_zr_oss_exempt_report.setProperty("acc_total_label", acc_total_label);
                        acc_sr_zr_oss_exempt_report.setProperty("acc_from_date", f_acc_date);
                        acc_sr_zr_oss_exempt_report.setProperty("acc_to_date", t_acc_date);
                        acc_sr_zr_oss_exempt_report.setProperty("acc_invoice_number", sop_invoice_no);
                        acc_sr_zr_oss_exempt_report.setProperty("acc_invoice_description", acc_invoice_description);
                        acc_sr_zr_oss_exempt_report.setProperty("acc_paging_no", j.ToString());
                        var acc_currency = myInnovator.newItem("acc_currency", "get");
                        acc_currency.setProperty("id", pop_currency);
                        acc_currency.setPropertyCondition("id", "eq");
                        acc_currency = acc_currency.apply();
                        var acc_currecny_code = "";
                        var acc_currency_count = acc_currency.getItemCount();
                        if (acc_currency_count > 0)
                        {
                            acc_currecny_code = acc_currency.getItemByIndex(0).getProperty("acc_currencycode", "");
                            acc_sr_zr_oss_exempt_report.setProperty("acc_currecny_code", acc_currecny_code);
                        }

                        /* For LastMonthRate for SGD*/
                        var querysg = "select acc_currency.id,acc_currency.ACC_OPERATOR,acc_currencycode,acc_currency_detail.acc_monthly_rate,acc_currency_detail.acc_date" + " from innovator.acc_currency inner join innovator.acc_currency_detail" + " on  acc_currency.id=acc_currency_detail.source_id " + " where acc_currency.id='374D7C8DC875411A9A3BD0FC5A8BC066' " + " and DATEPART(m, acc_currency_detail.acc_date) = DATEPART(m, DATEADD(m, -1, '" + sop_invoice_date + "')) AND DATEPART(yyyy, acc_currency_detail.acc_date) = DATEPART(yyyy, DATEADD(m, -1, '" + sop_invoice_date + "'))";

                        Item result_lastmonthrate = myInnovator.applySQL(querysg);
                        var sglastMonthRate = result_lastmonthrate.getProperty("acc_monthly_rate", "");
                        /* For LastMonthRate for SGD*/

                        var parameter = "<currency_id>" + pop_currency + "</currency_id>" +
                        "<pop_invoice_date>" + sop_invoice_date + "</pop_invoice_date>";
                        var sg_rate = "";
                        var sg_operator = "";
                        var return_result = myInnovator.applyMethod("acc_GetLastMonthRate", parameter);
                        var return_result_count = return_result.getItemCount();
                        if (return_result_count > 0)
                        {
                            for (var y = 0; y < return_result_count; y++)
                            {
                                var _get_data_return_result = return_result.getItemByIndex(y);
                                sg_rate = _get_data_return_result.getProperty("acc_monthly_rate", "");
                                sg_operator = _get_data_return_result.getProperty("acc_operator", "");
                            }
                        }
                        if (acc_currecny_code == "USD")
                        {
                            // pop_sg_sub_amount = (Convert.ToDecimal(pop_sg_sub_amount) * Convert.ToDecimal(sglastMonthRate)).ToString();
                            // pop_sg_gst_amount = (Convert.ToDecimal(pop_sg_gst_amount) * Convert.ToDecimal(sglastMonthRate)).ToString();
                            // acc_sr_zr_oss_exempt_report.setProperty("acc_invoice_amount_gst", pop_sg_sub_amount);
                            // acc_sr_zr_oss_exempt_report.setProperty("acc_gst_per_invoice", pop_sg_gst_amount);
                        }
                        else if (acc_currecny_code == "SGD")
                        {
                            // acc_sr_zr_oss_exempt_report.setProperty("acc_invoice_amount_gst", pop_sg_sub_amount);
                            // acc_sr_zr_oss_exempt_report.setProperty("acc_gst_per_invoice", pop_sg_gst_amount);
                        }
                        else
                        {
                            // pop_sg_sub_amount = (Convert.ToDecimal(pop_sg_sub_amount) / Convert.ToDecimal(sg_rate) * Convert.ToDecimal(sglastMonthRate)).ToString();
                            // pop_sg_gst_amount = (Convert.ToDecimal(pop_sg_gst_amount) / Convert.ToDecimal(sg_rate) * Convert.ToDecimal(sglastMonthRate)).ToString();
                            // acc_sr_zr_oss_exempt_report.setProperty("acc_invoice_amount_gst", pop_sg_sub_amount);
                            // acc_sr_zr_oss_exempt_report.setProperty("acc_gst_per_invoice", pop_sg_gst_amount);
                        }
                        acc_sr_zr_oss_exempt_report.setProperty("acc_invoice_amount_gst", pop_sg_sub_amount);
                        acc_sr_zr_oss_exempt_report.setProperty("acc_gst_per_invoice", pop_sg_gst_amount);
                        acc_sr_zr_oss_exempt_report.setProperty("pop_sub_amount", pop_sub_amount);
                        acc_sr_zr_oss_exempt_report = acc_sr_zr_oss_exempt_report.apply();
                        int icount = acc_sr_zr_oss_exempt_report.getItemCount();
                        if (acc_sr_zr_oss_exempt_report.isError())
                        {
                            return myInnovator.newError("Error Inserting GST Report");
                        }
                    }
                }
            }
            catch (System.Exception ex)
            {
                result = myInnovator.newError(string.Format("SYSTEM EXCEPTION in method {0}\n{1}", MethodName, ex.Message));
                ////result.setErrorCode("0");		//only use if this method is called from another method
            }
            finally
            {
                //**** REVOKE IDENTITY PRIVILEGES
                // revokeIdentityPrivileges();
                //*******************************
            }

            return result;
        }
        /// <summary>
        /// This section is to allow the current method to assume the privileges of a specific identity.
        /// For instance calling: grantIdentityPrivileges("Aras PLM"); will allow this method all of the
        /// rights of the Aras PLM identity.
        /// The revokeIdentityPrivileges() method will removed the privileges added for this method. It
        /// must be called from before the method exits. Most likely in the Finally of the main method code.
        /// If different identity privileges must be granted a second time within the same method, first use
        /// revokeIdentityPrivileges() to remove the first privileges before granting new ones.
        /// </summary>

        private string AssignedIdentity;

        /// <summary>
        /// If required, call this helper function to run this method as another Identity. 
        /// Ensure that you call the revokeIdentityPrivileges helper function in the 
        /// finally block to revoke the Identity privilege when this method completes.
        /// </summary>
        public void grantIdentityPrivileges(string assignedIdent)
        {
            if (!string.IsNullOrEmpty(AssignedIdentity))
            {
                revokeIdentityPrivileges();
            }

            Aras.Server.Security.Identity secIdentity = Aras.Server.Security.Identity.GetByName(assignedIdent);
            if (Aras.Server.Security.Permissions.GrantIdentity(secIdentity))
            {
                AssignedIdentity = assignedIdent;
            }
        }

        /// <summary>
        /// If you granted security privileges, then you need to ensure that you revoke the privilege.
        /// </summary>
        public void revokeIdentityPrivileges()
        {
            if (AssignedIdentity != null)
            {
                Aras.Server.Security.Permissions.RevokeIdentity(Aras.Server.Security.Identity.GetByName(AssignedIdentity));
                AssignedIdentity = null;
            }]]></method_code>
  <method_type>C#</method_type>
  <name>acc_sr_zr_oss_exempt_rpt</name>
 </Item>
</AML>